# Interface ICefFrame

Description
Hierarchy
Fields
Methods
Properties

## Unit

uCEFInterfaces

## Declaration

`type ICefFrame = interface(ICefBaseRefCounted)`

## Description

Interface used to represent a frame in the browser window. When used in the browser process the functions of this interface may be called on any thread unless otherwise indicated in the comments. When used in the render process the functions of this interface may only be called on the main thread.

UNKNOWN

<see href="https://bitbucket.org/chromiumembedded/cef/src/master/include/capi/cef_frame_capi.h">CEF source file: /include/capi/cef_frame_capi.h (cef_frame_t))

## Hierarchy

- IInterface
- ICefBaseRefCounted
- ICefFrame

## Overview

### Methods

| `function IsValid: Boolean;`
| `procedure Undo;`
| `procedure Redo;`
| `procedure Cut;`
| `procedure Copy;`
| `procedure Paste;`
| `procedure PasteAndMatchStyle;`
| `procedure Del;`
| `procedure SelectAll;`
| `procedure ViewSource;`
| `procedure GetSource(const visitor: ICefStringVisitor);`
| `procedure GetSourceProc(const proc: TCefStringVisitorProc);`
| `procedure GetText(const visitor: ICefStringVisitor);`
| `procedure GetTextProc(const proc: TCefStringVisitorProc);`
| `procedure LoadRequest(const request: ICefRequest);`
| `procedure LoadUrl(const url: ustring);`
| `procedure ExecuteJavaScript(const code, scriptUrl: ustring; startLine: Integer);`
| `function IsMain: Boolean;`
| `function IsFocused: Boolean;`
| `function GetName: ustring;`
| `function GetIdentifier: ustring;`
| `function GetParent: ICefFrame;`
| `function GetUrl: ustring;`
| `function GetBrowser: ICefBrowser;`
| `function GetV8Context: ICefv8Context;`
| `procedure VisitDom(const visitor: ICefDomVisitor);`
| `procedure VisitDomProc(const proc: TCefDomVisitorProc);`
| `function CreateUrlRequest(const request: ICefRequest; const client: ICefUrlrequestClient): ICefUrlRequest;`
| `procedure SendProcessMessage(targetProcess: TCefProcessId; const message_: ICefProcessMessage);`

### Properties

| `property Name : ustring read GetName;`
| `property Url : ustring read GetUrl;`
| `property Browser : ICefBrowser read GetBrowser;`
| `property Parent : ICefFrame read GetParent;`
| `property Identifier : ustring read GetIdentifier;`

## Description

### Methods

| `function IsValid: Boolean;`
True if this object is currently attached to a valid frame. ###### Attributes GUID['{8FD3D3A6-EA3A-4A72-8501-0276BD5C3D1D}']

| `procedure Undo;`
Execute undo in this frame.

| `procedure Redo;`
Execute redo in this frame.

| `procedure Cut;`
Execute cut in this frame.

| `procedure Copy;`
Execute copy in this frame.

| `procedure Paste;`
Execute paste in this frame.

| `procedure PasteAndMatchStyle;`
Execute paste and match style in this frame.

| `procedure Del;`
Execute delete in this frame.

| `procedure SelectAll;`
Execute select all in this frame.

| `procedure ViewSource;`
Save this frame's HTML source to a temporary file and open it in the default text viewing application. This function can only be called from the browser process.

| `procedure GetSource(const visitor: ICefStringVisitor);`
Retrieve this frame's HTML source as a string sent to the specified visitor.

| `procedure GetSourceProc(const proc: TCefStringVisitorProc);`
Retrieve this frame's HTML source as a string sent to the specified visitor.

| `procedure GetText(const visitor: ICefStringVisitor);`
Retrieve this frame's display text as a string sent to the specified visitor.

| `procedure GetTextProc(const proc: TCefStringVisitorProc);`
Retrieve this frame's display text as a string sent to the specified visitor.

| `procedure LoadRequest(const request: ICefRequest);`
Load the request represented by the |request| object. WARNING: This function will fail with "bad IPC message" reason INVALID_INITIATOR_ORIGIN (213) unless you first navigate to the request origin using some other mechanism (LoadURL, link click, etc).

| `procedure LoadUrl(const url: ustring);`
Load the specified |url|.

| `procedure ExecuteJavaScript(const code, scriptUrl: ustring; startLine: Integer);`
Execute a string of JavaScript code in this frame. The |script_url| parameter is the URL where the script in question can be found, if any. The renderer may request this URL to show the developer the source of the error. The |start_line| parameter is the base line number to use for error reporting.

| `function IsMain: Boolean;`
Returns true (1) if this is the main (top-level) frame.

| `function IsFocused: Boolean;`
Returns true (1) if this is the focused frame.

| `function GetName: ustring;`
Returns the name for this frame. If the frame has an assigned name (for example, set via the iframe "name" attribute) then that value will be returned. Otherwise a unique name will be constructed based on the frame parent hierarchy. The main (top-level) frame will always have an NULL name value.

| `function GetIdentifier: ustring;`
Returns the globally unique identifier for this frame or empty if the underlying frame does not yet exist.

| `function GetParent: ICefFrame;`
Returns the parent of this frame or NULL if this is the main (top-level) frame.

| `function GetUrl: ustring;`
Returns the URL currently loaded in this frame.

| `function GetBrowser: ICefBrowser;`
Returns the browser that this frame belongs to.

| `function GetV8Context: ICefv8Context;`
Get the V8 context associated with the frame. This function can only be called from the render process.

| `procedure VisitDom(const visitor: ICefDomVisitor);`
Visit the DOM document. This function can only be called from the render process.

| `procedure VisitDomProc(const proc: TCefDomVisitorProc);`
Visit the DOM document. This function can only be called from the render process.

| `function CreateUrlRequest(const request: ICefRequest; const client: ICefUrlrequestClient): ICefUrlRequest;`
Create a new URL request that will be treated as originating from this frame and the associated browser. Use TCustomCefUrlrequestClient.Create instead if you do not want the request to have this association, in which case it may be handled differently (see documentation on that function). A request created with this function may only originate from the browser process, and will behave as follows: - It may be intercepted by the client via CefResourceRequestHandler or CefSchemeHandlerFactory. - POST data may only contain a single element of type PDE_TYPE_FILE or PDE_TYPE_BYTES. The |request| object will be marked as read-only after calling this function.

| `procedure SendProcessMessage(targetProcess: TCefProcessId; const message_: ICefProcessMessage);`
Send a message to the specified |target_process|. Ownership of the message contents will be transferred and the |message| reference will be invalidated. Message delivery is not guaranteed in all cases (for example, if the browser is closing, navigating, or if the target process crashes). Send an ACK message back from the target process if confirmation is required.

### Properties

| `property Name : ustring read GetName;`
Returns the name for this frame. If the frame has an assigned name (for example, set via the iframe "name" attribute) then that value will be returned. Otherwise a unique name will be constructed based on the frame parent hierarchy. The main (top-level) frame will always have an NULL name value.

| `property Url : ustring read GetUrl;`
Returns the URL currently loaded in this frame.

| `property Browser : ICefBrowser read GetBrowser;`
Returns the browser that this frame belongs to.

| `property Parent : ICefFrame read GetParent;`
Returns the parent of this frame or NULL if this is the main (top-level) frame.

| `property Identifier : ustring read GetIdentifier;`
Returns the globally unique identifier for this frame or empty if the underlying frame does not yet exist.

Generated by PasDoc 0.16.0-snapshot.